$TITLE ('RTX-51/BCAN HW-DEFINITIONS')
$NOXREF
$NOSYMBOLS
$NORB
$DEBUG
$PAGELENGTH(80) PAGEWIDTH(110)
;************************************************************************
;************************************************************************
;*                                                                      *
;*  HW-DEFINITIONS FOR RTX-51 / 80592-CAN DRIVER                        *
;*                                                                      *
;************************************************************************
;************************************************************************
;*                                                                      *
;*  PURPOSE:        User confuguration of Buffer allocation             *
;*                  and timeouts for the RTX-51/80592-CAN Driver        *
;*                  This source file is part of the RTX-51/CAN          *
;*                  object code disk.                                   *
;*                                                                      *
;*  FILENAME:       CCONF592.A51                                        *
;*                                                                      *
;*  MODULENAME:     --                                                  *
;*                                                                      *
;*  TARGETSYSTEM:   Any system based upon Philips 80592                 *
;*                                                                      *
;*  LANGUAGE:       Keil ASM-51                                         *
;*                                                                      *
;************************************************************************
;*  REVISION HISTORY :                                                  *
;*                                                                      *
;*  - 14. OKT 1991; Th. Fischler; Rev 1.0 :                             *
;*       First Version                                                  *
;*                                                                      *
;************************************************************************
;*    Copyright 1991 .. 2001 METTLER  &  FUCHS  AG,  CH-8953 Dietikon   *
;************************************************************************


PUBLIC  CAN_OBJ_BUF, CAN_OBJ_BUF_START, CAN_OBJ_BUF_END
PUBLIC  CAN_INT_NBR
PUBLIC  NBR_OF_SEND_TRIALS


;************************************************************************
;*                                                                      *
;*   THE FOLLOWING VALUES CAN BE ALTERED BY THE USER                    *
;*                                                                      *
;************************************************************************


; 14 bytes from the object-buffer are reserved for internal use
; each defined object needs 14 bytes from the object buffer
; so with an object-buffer length of 28 bytes you can define 1 object
; and with an object-buffer length of 42 byte you can define 2 objects
;
; object_buffer_lengt = (max-number-of-objects * 14) + 14
;

OBJ_BUFFER_LENGTH       EQU 200         ; Number of bytes for the
                                        ; object-buffer


; The next constant defines the number of send-trials for the first
; communication object after startup in number of system-clocks.
; (0 to 255 / Default 10)

MAX_NBR_OF_SEND_TRIALS  EQU 10


;************************************************************************
;*                                                                      *
;*   DO NOT ALTER THE FOLLOWING DECLARATIONS !!!                        *
;*                                                                      *
;************************************************************************

; Object-Buffer declaration

CAN_OBJ_BUF_SEG         SEGMENT         XDATA
                        RSEG            CAN_OBJ_BUF_SEG
CAN_OBJ_BUF_START:
CAN_OBJ_BUF:            DS OBJ_BUFFER_LENGTH      ; Object-Buffer Length
CAN_OBJ_BUF_END:


; Constant declaration
?CO?CAN_CONST_SEG          SEGMENT         CODE
                           RSEG            ?CO?CAN_CONST_SEG
NBR_OF_SEND_TRIALS:        DB MAX_NBR_OF_SEND_TRIALS
CAN_INT_NBR:               DB 5          ; Interrupt 5 used for CAN

;
;   END OF MODULE
    END
