/***********************************************************************
*                                                                      *
*  H E A D E R - F I L E                                               *
*                                                                      *
*  F U L L - C A N   C O N T R O L L E R                               *
*                                                                      *
************************************************************************/


   /* Erstes Byte im internen Speicher des C515C das fr CAN-Objekte   */
   /* benutzt werden darf. Die interne Start-Adresse des ersten        */
   /* Objektes entspricht CONTR_BUF_START_ADR                          */
   #define CONTR_BUF_START_ADR  0x10

   /* Letztes Byte im internen Speicher des C515C das fr CAN-Objekte  */
   /* benutzt werden darf.                                             */
   /* Objektes entspricht CONTR_BUF_START_ADR                          */
   #define CONTR_BUF_END_ADR  0xF0

   /* Die Lnge einer Meldung im internen CAN Speicher des C515C       */
   /* (genaueres siehe Siemens C515C Manual)                           */
   #define MESSAGE_SIZE  0x10

   /* Returnwerte von c_get_int_typ */
   enum interrupt_t {no_int, error_int, obj_int};

   /* Returnwerte von c_get_status  */
   enum can_bus_stat_t {error_active, error_passive, bus_off};

byte c_hw_init (byte bus_t0_reg,
                byte bus_t1_reg,
                byte dummy_1,
                byte dummy_2);

void c_init_obj (unsigned long ident,
                 byte         data_len,
                 byte         obj_typ,
                 byte         obj_adr,
                 byte         standart);

void c_start (void);

void c_stop (void);

void c_read_obj (byte obj_adr,
                 byte xdata *arr);

byte c_send_obj (byte obj_adr,
                 byte remote,
                 byte xdata *arr);

byte c_write_obj (byte obj_adr,
                  byte xdata *arr);

void c_write_end_mark (byte obj_adr);

enum interrupt_t c_get_int_typ (void);

byte c_get_obj_int_adr (void);

void c_receipt_obj_int (byte obj_adr);

void c_receipt_error_int (void);

enum can_bus_stat_t c_get_status (void);

