

$EJECT
;=======================================================================
;
;     INCLUDE FILE DES MODULS GCANAPIF.A51
;
;=======================================================================



;*---------------------------------------------------------------------*
;*     C A N _ T A S K _ C R E A T E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Starten des CAN-Task. Als erste Operation muss immer diese
;*     Funktion ausgefhrt werden, alle weiteren CAN-Operationen
;*     drfen nur nach dem Aufruf dieser Operation ausgefhrt werden.
;*
;* VAR
;*    I : BYTE;
;*
;* BEGIN
;*    C_DRIVER_IN_USE := FALSE;
;*    FOR I:=0 TO 2 DO
;*       C_TEMP_ORDER_BUF[I].OCCUPIED := FALSE;
;*    END FOR;
;*    CAN-Task starten;
;*    IF Task-gestartet THEN
;*       RETURN C_OK;
;*    ELSE
;*       RETURN C_NOT_STARTED;
;*    END;
;* END CAN_TASK_CREATE;
;*
;*---------------------------------------------------------------------*
;*  Parameter:
;*
;*     --
;*
;*  Returnwert im AKKU :
;*
;*        C_OK          :   CAN-Task gestartet
;*        C_NOT_STARTED :   CAN-Task konnte nicht gestartet werden
;*
;*---------------------------------------------------------------------*/

?CAN?can_task_create?GCANAPIF    SEGMENT CODE
                                 RSEG    ?CAN?can_task_create?GCANAPIF

can_task_create:
                        ; Globale Variablen Initialisieren
                        CLR     C_DRIVER_IN_USE
                        MOV     A,#FALSE
                        MOV     DPTR,#C_TEMP_BUF_0_OCC
                        MOVX    @DPTR,A
                        MOV     DPTR,#C_TEMP_BUF_1_OCC
                        MOVX    @DPTR,A
                        MOV     DPTR,#C_TEMP_BUF_2_OCC
                        MOVX    @DPTR,A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_create_task
                        ; Rckgabewert auswerten
                        MOV     A, R7
                        JNZ     CTS_1
                        ; Task gestartet
                        MOV     R7, #C_OK
                        RET
CTS_1:                  ; Task konnte nicht gestartet werden
                        MOV     R7, #C_NOT_STARTED
                        RET

$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ H W _ I N I T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Grundlegende HW-Initialisierung des CAN-Controllers, Lschen
;*     aller Kommunikationsobjekte. Nach einem CAN_HW_INIT ist der
;*     CAN-Treiber bereit zu einer kompletten Neudefinition aller
;*     Kommunikationsobjekte.
;*
;* BEGIN
;*    R3 := BUS_TIMING_0;       BUS_TIMING_0
;*    R4 := BUS_TIMING_1;       BUS_TIMING_1
;*    R5 := OUT_CONTROL;        BUS_CONFIG
;*    R6 := SYNCON              CPU_INTERFACE
;*    R7 := SLEEP_MODE;         KEINE VERWENDUNG
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_HW_INIT_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.PARAM[2] := R5;
;*       C_ORDER_BUF.PARAM[3] := R6;
;*       C_ORDER_BUF.PARAM[4] := R7;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?_can_hw_init?BYTE) :
;*
;*     1. Byte : BUS_TIMING_0    Bus-Timing Register 0 des CAN-Controllers
;*     2. Byte : BUS_TIMING_1    Bus-Timing Register 1 des CAN-Controllers
;*     3. Byte : OUT_CONTROL     Konfiguration der Ausgangstreiber des CAN-
;*                               Controllers
;*     4. Byte : SYNCON          Resynchronisations-Mode des CAN-Controllers
;*     5. Byte : SLEEP_MODE      Sleep-Mode des CAN-Controllers
;*                               0  :  kein Sleep-Mode
;*                               1  :  Sleep-Mode ist aktiv
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Funktion ausgefhrt
;*        C_CONF_ERROR        Unmgliches Bus-Timing oder OUT_CONTROL Wert
;*        C_CAN_FAILURE       Probleme mit dem CAN-Controller
;*                            (falsche Adresse usw.)
;*
;*---------------------------------------------------------------------*/

;* Bereich fr die Parameter-Uebergabe (mehr als 3 Parameter)
?XD?_can_hw_init?GCANAPIF        SEGMENT XDATA
                                RSEG ?XD?_can_hw_init?GCANAPIF
?_can_hw_init?BYTE:
bus_timing_0:           DS 1
bus_timing_1:           DS 1
out_control:            DS 1
syncon:                 DS 1
sleep_mode:             DS 1


?CAN?_can_hw_init?GCANAPIF     SEGMENT CODE
                              RSEG    ?CAN?_can_hw_init?GCANAPIF

_can_hw_init:
                        ; Parameter in die Register holen
                        ; die ersten 3 Parameter sind bereits in den Regs.
                        MOV     A, R5
                        MOV     R4, A               ; speichere Bus-timing-1

                        MOV     A, R3
                        MOV     R5, A               ; speichere out-control

                        MOV     A, R7
                        MOV     R3, A               ; speichere bus-timing-0

                        MOV     DPTR, #syncon
                        MOVX    A, @DPTR
                        MOV     R6, A
                        INC     DPTR
                        MOVX    A, @DPTR
                        MOV     R7, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CHI_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_HW_INIT_ORDER, 5

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CHI_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ D E F _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Definieren eines neuen Kommunikationsobjekts. Diese Funktion
;*     kann nur nach CAN_HW_INIT oder nach CAN_STOP ausgefhrt werden.
;*     Es knnen Objekte definiert werden, bis der Objekt-Speicher voll
;*     ist (beim Full-CAN ist dies das Controller-interne Dual-Port RAM,
;*     beim Basic-CAN wird der Objekt-Speicher im externen RAM alloziert)
;*     oder die maximale Anzahl von 255 definierten Objekten erreicht ist.
;*     Falls ein Objekt definiert wird, dass bereits existiert, wird eine
;*     Fehlermeldung (in CANRETURN) zurckgegeben.
;*     Nach der Beendigung der Initialisierung kann der CAN-Treiber mit
;*     CAN_START gestartet werden.
;*
;* BEGIN
;*    R3 := HIGH(IDENTIFIER);
;*    R4 := LOW(IDENTIFIER);
;*    R5 := DATA_LENGTH;
;*    R6 := OBJECT_TYP;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_DEF_OBJ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.PARAM[2] := R5;
;*       C_ORDER_BUF.PARAM[3] := R6;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*    R6/R7   : IDENTIFIER       Identifikation des Kommunikationsobjektes
;*                               entsprechend der CAN-Definition (0 .. 7EFH)
;*    R5      : DATA_LENGTH      Anzahl Datenbyte im Objekt (0..8)
;*    R3      : OBJECT_TYP       Genauere Beschreibung der Verwendungsart
;*                               des Objektes
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Objekt definiert
;*        C_NOT_STOPPED       CAN_STOP oder CAN_HW_INIT muss vor der
;*                            Ausfhrung dieser Funktion aufgerufen werden
;*        C_OBJ_ERROR         Objekt existiert schon
;*        C_TOO_LONG          DATA_LENGTH ist grsser als 8
;*        C_INVALID_TYPE      Falscher Objekttyp
;*        C_MEM_FULL          Objekt-Speicher ist voll, es knnen keine
;*                            neuen Objekte definiert werden
;*                            (zuerst alle Objekte mit CAN_HW_INIT lschen).
;*                            Entweder sind bereits 255 Objekte definiert
;*                            oder der Objekt-Speicher ist voll.
;*
;*---------------------------------------------------------------------*/


?CAN?_can_def_obj?GCANAPIF     SEGMENT CODE
                              RSEG    ?CAN?_can_def_obj?GCANAPIF
_can_def_obj:
                        XCHR    R6, R3
                        MOV     A, R7
                        MOV     R4, A
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CDO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_DEF_OBJ_ORDER, 4

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CDO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ D E F _ O B J _ E X T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Definieren eines neuen Kommunikationsobjekts. Diese Funktion
;*     kann nur nach CAN_HW_INIT oder nach CAN_STOP ausgefhrt werden.
;*     Es knnen Objekte definiert werden, bis der Objekt-Speicher voll
;*     ist (beim Full-CAN ist dies das Controller-interne Dual-Port RAM,
;*     beim Basic-CAN wird der Objekt-Speicher im externen RAM alloziert)
;*     oder die maximale Anzahl von 255 definierten Objekten erreicht ist.
;*     Falls ein Objekt definiert wird, dass bereits existiert, wird eine
;*     Fehlermeldung (in CANRETURN) zurckgegeben.
;*     Nach der Beendigung der Initialisierung kann der CAN-Treiber mit
;*     CAN_START gestartet werden.
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_DEF_OBJ_ORDER_EXT;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.PARAM[4] := dat_len;
;*       C_ORDER_BUF.PARAM[5] := oby_typ ;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*    R4/R7   : IDENTIFIER       Identifikation des Kommunikationsobjektes
;*                               entsprechend der CAN-Definition (0 .. 7EFH)
;*    dat_len : DATA_LENGTH      Anzahl Datenbyte im Objekt (0..8)
;*    obj_typ : OBJECT_TYP       Genauere Beschreibung der Verwendungsart
;*                               des Objektes
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Objekt definiert
;*        C_NOT_STOPPED       CAN_STOP oder CAN_HW_INIT muss vor der
;*                            Ausfhrung dieser Funktion aufgerufen werden
;*        C_OBJ_ERROR         Objekt existiert schon
;*        C_TOO_LONG          DATA_LENGTH ist grsser als 8
;*        C_INVALID_TYPE      Falscher Objekttyp
;*        C_MEM_FULL          Objekt-Speicher ist voll, es knnen keine
;*                            neuen Objekte definiert werden
;*                            (zuerst alle Objekte mit CAN_HW_INIT lschen).
;*                            Entweder sind bereits 255 Objekte definiert
;*                            oder der Objekt-Speicher ist voll.
;*
;*---------------------------------------------------------------------*/

?XD?_can_def_obj_ext?GCANAPIF        SEGMENT XDATA
                                RSEG ?XD?_can_def_obj_ext?GCANAPIF
?_can_def_obj_ext?BYTE:
ident:           DS 4
dat_len:         DS 1
obj_typ:         DS 1


?CAN?_can_def_obj_ext?GCANAPIF  SEGMENT CODE
                                RSEG    ?CAN?_can_def_obj_ext?GCANAPIF

_can_def_obj_ext:
                        MOV     A,R4
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    @DPTR, A

                        MOV     A,R5
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 1
                        MOVX    @DPTR, A

                        MOV     A,R6
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 2
                        MOVX    @DPTR, A

                        MOV     A,R7
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 3
                        MOVX    @DPTR, A

                        MOV     DPTR, #dat_len
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 4
                        MOVX    @DPTR, A

                        MOV     DPTR, #obj_typ
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 5
                        MOVX    @DPTR, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CDOX_1

                        SETUP_ORDER CAN_DEF_OBJ_ORDER_EXT, 0
                        ; Befehle an CAN-Task aufsetzen

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CDOX_1:                 MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ D E F _ L _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Definieren 15. standart Kommunikationsobjekts. Diese Funktion
;*     kann nur nach CAN_HW_INIT oder nach CAN_STOP ausgefhrt werden.
;*     Es knnen Objekte definiert werden, bis der Objekt-Speicher voll
;*     ist (beim Full-CAN ist dies das Controller-interne Dual-Port RAM,
;*     beim Basic-CAN wird der Objekt-Speicher im externen RAM alloziert)
;*     oder die maximale Anzahl von 255 definierten Objekten erreicht ist.
;*     Falls ein Objekt definiert wird, dass bereits existiert, wird eine
;*     Fehlermeldung (in CANRETURN) zurckgegeben.
;*     Nach der Beendigung der Initialisierung kann der CAN-Treiber mit
;*     CAN_START gestartet werden.
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_DEF_L_OBJ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.PARAM[4] := dat_len;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*    R4/R7   : IDENTIFIER    Identifikation des Kommunikationsobjektes
;*                            entsprechend der CAN-Definition (0 .. 7EFH)
;*    dat_len : DATA_LENGTH   Anzahl Datenbyte im Objekt (0..8)
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Objekt definiert
;*        C_NOT_STOPPED       CAN_STOP oder CAN_HW_INIT muss vor der
;*                            Ausfhrung dieser Funktion aufgerufen werden
;*        C_OBJ_ERROR         Objekt existiert schon
;*        C_TOO_LONG          DATA_LENGTH ist grsser als 8
;*        C_INVALID_TYPE      Falscher Objekttyp
;*        C_MEM_FULL          Objekt-Speicher ist voll, es knnen keine
;*                            neuen Objekte definiert werden
;*                            (zuerst alle Objekte mit CAN_HW_INIT lschen).
;*                            Entweder sind bereits 255 Objekte definiert
;*                            oder der Objekt-Speicher ist voll.
;*
;*---------------------------------------------------------------------*/

?XD?_can_def_last_obj?GCANAPIF  SEGMENT XDATA
                                RSEG ?XD?_can_def_last_obj?GCANAPIF
?_can_def_last_obj?BYTE:
l_ident:           DS 4
l_dat_len:         DS 1


?CAN?_can_def_last_obj?GCANAPIF SEGMENT CODE
                                 RSEG    ?CAN?_can_def_last_obj?GCANAPIF

_can_def_last_obj:
                        MOV     A,R4
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    @DPTR, A

                        MOV     A,R5
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 1
                        MOVX    @DPTR, A

                        MOV     A,R6
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 2
                        MOVX    @DPTR, A

                        MOV     A,R7
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 3
                        MOVX    @DPTR, A

                        MOV     DPTR, #l_dat_len
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 4
                        MOVX    @DPTR, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, L_CDOX_1

                        SETUP_ORDER CAN_DEF_L_OBJ_ORDER, 0
                        ; Befehle an CAN-Task aufsetzen

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

L_CDOX_1:               MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ D E F _ L _ O B J _ E X T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Definieren 15. extended Kommunikationsobjekts. Diese Funktion
;*     kann nur nach CAN_HW_INIT oder nach CAN_STOP ausgefhrt werden.
;*     Es knnen Objekte definiert werden, bis der Objekt-Speicher voll
;*     ist (beim Full-CAN ist dies das Controller-interne Dual-Port RAM,
;*     beim Basic-CAN wird der Objekt-Speicher im externen RAM alloziert)
;*     oder die maximale Anzahl von 255 definierten Objekten erreicht ist.
;*     Falls ein Objekt definiert wird, dass bereits existiert, wird eine
;*     Fehlermeldung (in CANRETURN) zurckgegeben.
;*     Nach der Beendigung der Initialisierung kann der CAN-Treiber mit
;*     CAN_START gestartet werden.
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_DEF_L_OBJ_ORDER_EXT;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.PARAM[4] := dat_len;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_HW_INIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*    R4/R7   : IDENTIFIER    Identifikation des Kommunikationsobjektes
;*                            entsprechend der CAN-Definition (0 .. 7EFH)
;*    dat_len : DATA_LENGTH   Anzahl Datenbyte im Objekt (0..8)
;*
;*
;*  Returnwert in R7 :
;*
;*        C_OK                Objekt definiert
;*        C_NOT_STOPPED       CAN_STOP oder CAN_HW_INIT muss vor der
;*                            Ausfhrung dieser Funktion aufgerufen werden
;*        C_OBJ_ERROR         Objekt existiert schon
;*        C_TOO_LONG          DATA_LENGTH ist grsser als 8
;*        C_INVALID_TYPE      Falscher Objekttyp
;*        C_MEM_FULL          Objekt-Speicher ist voll, es knnen keine
;*                            neuen Objekte definiert werden
;*                            (zuerst alle Objekte mit CAN_HW_INIT lschen).
;*                            Entweder sind bereits 255 Objekte definiert
;*                            oder der Objekt-Speicher ist voll.
;*
;*---------------------------------------------------------------------*/

?XD?_can_def_last_obj_ext?GCANAPIF  SEGMENT XDATA
                                 RSEG ?XD?_can_def_last_obj_ext?GCANAPIF
?_can_def_last_obj_ext?BYTE:
lx_ident:           DS 4
lx_dat_len:         DS 1


?CAN?_can_def_last_obj_ext?GCANAPIF SEGMENT CODE
                                 RSEG    ?CAN?_can_def_last_obj_ext?GCANAPIF

_can_def_last_obj_ext:
                        MOV     A,R4
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    @DPTR, A

                        MOV     A,R5
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 1
                        MOVX    @DPTR, A

                        MOV     A,R6
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 2
                        MOVX    @DPTR, A

                        MOV     A,R7
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 3
                        MOVX    @DPTR, A

                        MOV     DPTR, #lx_dat_len
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 4
                        MOVX    @DPTR, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, LX_CDOX_1

                        SETUP_ORDER CAN_DEF_L_OBJ_ORDER_EXT, 0
                        ; Befehle an CAN-Task aufsetzen

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

LX_CDOX_1:              MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ G E T _ S T A T U S
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Lesen des aktuellen CAN-Controller Status.
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_GET_STATUS_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_STOP;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*  Returnwert in R7 :
;*
;*        C_ERR_ACTIVE         Normale Operation
;*        C_ERR_PASSIVE        Error-passive mode erreicht
;*        C_BUS_OFF            CAN-Controller ist Bus-Off
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_get_status?GCANAPIF  SEGMENT CODE
                              RSEG    ?CAN?can_get_status?GCANAPIF

can_get_status:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CGS_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_GET_STATUS_ORDER, 0
                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam
                        JMP   COMMON_START_STOP_STATUS

CGS_1:                  MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S T O P
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Anhalten des CAN-Treibers zur Neudefinition von Objekten
;*     (mit CAN_DEF_OBJ) oder zum temporren Unterbrechen der
;*     Kommunikation. Im Unterschied zu CAN_HW_INIT werden bein Aufruf
;*     von CAN_STOP keine schon bestehenden Kommunikationsobjekte
;*     gelscht.
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_STOP_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_STOP;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*  Returnwert in R7 :
;*
;*        C_OK                 Treiber gestoppt
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_stop?GCANPIF   SEGMENT CODE
                        RSEG    ?CAN?can_stop?GCANPIF

can_stop:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CSP_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_STOP_ORDER, 0
                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam
                        JMP   COMMON_START_STOP_STATUS

CSP_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S T A R T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Starten des CAN-Treibers nach CAN_STOP oder nach CAN_DEF_OBJ
;*     (CAN_DEF_OBJ kann nur nach CAN_STOP oder CAN_HW_INIT ausgefhrt
;*     werden).
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_STOP_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_START;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     --
;*
;*     Returnwert in R7:
;*
;*        C_OK                 Treiber gestoppt
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/

?CAN?can_start?GCANPIF   SEGMENT CODE
                         RSEG    ?CAN?can_start?GCANPIF

can_start:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CST_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_START_ORDER, 0


                        ; Der Rest des Codes ist fr CAN_START, CAN_STOP
                        ; und CAN_GET_STATUS gemeinsam

                        ; CAN-Task starten
COMMON_START_STOP_STATUS:
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CST_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ S E N D
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Senden eines vorher mit CAN_DEF_OBJ definierten Objektes ber
;*     den CAN-Bus.
;*
;* BEGIN
;*    R3 := HIGH(MSG_PTR);
;*    R4 := LOW(MSG_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_SEND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_SEND;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7   : MSG_PTR       Pointer zu einer Struktur vom Typ
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Objekt wird gesendet
;*        C_OBJ_ERROR          Das Objekt mit der angegebenen
;*                             Identifikation ist nicht bekannt oder
;*                             das Objekt kann nicht gesendet werden
;*                             (OBJECT_TYP in CAN_DEF_OBJ ist nur auf
;*                             Empfang)
;*        C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_send?GCANPIF     SEGMENT CODE
                           RSEG    ?CAN?_can_send?GCANPIF

_can_send:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CSE_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_SEND_ORDER, 2

                        ; Der Rest des Codes ist fr CAN_WRITE und CAN_SEND
                        ; gemeinsam
                        JMP   COMMON_WRITE_SEND

CSE_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ W R I T E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Mit CAN_SEND wird ein Objekt direkt ber den CAN-Bus gesendet.
;*     Mit CAN_WRITE knnen neue Daten in ein Objekt geschrieben werden,
;*     ohne es sofort zu Senden. Falls dieses Objekt auf Remote-Frames
;*     antworten kann (wird mit CAN_DEF_OBJ festgelegt), werden beim
;*     Eintreffen eines entsprechenden Remote-Frames von einem anderen
;*     Knoten, diese neuen Daten ausgesendet.
;*
;* BEGIN
;*    R3 := HIGH(MSG_PTR);
;*    R4 := LOW(MSG_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_WRITE_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_WRITE;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7   : MSG_PTR       Pointer zu einer Struktur vom Typ
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Objekt wurde neu beschrieben
;*        C_OBJ_ERROR          Das Objekt mit der angegebenen
;*                             Identifikation ist nicht bekannt oder das
;*                             Objekt kann nicht gesendet werden
;*                             (OBJECT_TYP in CAN_DEF_OBJ ist nur
;*                             auf Empfang)
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_write?GCANPIF     SEGMENT CODE
                            RSEG    ?CAN?_can_write?GCANPIF

_can_write:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWR_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_WRITE_ORDER, 2

                        ; Der Rest des Codes ist fr CAN_WRITE und CAN_SEND
                        ; gemeinsam

                        ; CAN-Task starten
COMMON_WRITE_SEND:
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait

                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CWR_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E C E I V E
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Empfangen aller normalen Objekte (alle die nicht mit
;*     CAN_BIND_OBJ einem bestimmten Task zugeordnet sind). Die
;*     empfangenen Meldungen werden in einer Mailbox
;*     zwischengespeichert. Es knnen maximal 8 Objekte zwischengespeichert
;*     werden. Falls der Applikationstask die Objekte nicht aus
;*     der Mailbox liest gehen alle weiteren Objekte verloren
;*     (sie werden dem Applikationstask nicht bermittelt).
;*
;* BEGIN
;*    R3 := TIMEOUT;
;*    R4 := HIGH(BUFFER_PTR);
;*    R5 := LOW(BUFFER_PTR);
;*    PUSH R4;
;*    PUSH R5;
;*    ret = os_wait (K_TMO + K_MBX + 7, R3, BUFFER_PTR (* R4 und R5 *));
;*    POP R5;
;*    POP R4;
;*    IF ret = TMO_EVENT THEN
;*       RETURN C_TIMEOUT;
;*    END;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_W_IND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := Wert an der Adresse BUFFER_PTR+1 (* R4,R5 *)
;*       (* Der CAN-Task sendet ber die Mailbox den Index des empfangenen *)
;*       (* Objektes, dieser Index wird an die Adresse BUFFER_PTR          *)
;*       (* abgespeichert -> BUFFER_PTR als Argument bei RTX_WAIT          *)
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_RECEIVE;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R7      : TIMEOUT           Timeout falls in einer bestimmten Zeit
;*                                 kein Objekt empfangen wurde. Definition
;*                                 analog RTX-51;
;*                                 0        :  Kein Timeout, falls kein
;*                                             Objekt vorhanden ist, luft
;*                                             der Applikations-Task weiter
;*                                             ohne zu warten
;*                                 1..254   :  Anzahl RTX-51 Systemticks
;*                                             die der Applikations-Task
;*                                             auf ein Objekt warten soll
;*                                 255      :  Warten bis ein Objekt
;*                                             empfangen wurde
;*                                             (wait forever)
;*
;*     R4/R5   : BUFFER_PTR    Pointer zu einer Struktur von Typ
;*                             CAN_MESSAGE_STRUCT im externen RAM.
;*                             Der CAN-Treiber kopiert das empfangene
;*                             Objekt in diese Variable.
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Es wurde ein Objekt empfangen
;*        C_TIMEOUT            Es wurde innerhalb der mit TIMEOUT
;*                             angegebenen Zeit kein Objekt empfangen
;*        C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_receive?GCANPIF        SEGMENT CODE
                                 RSEG    ?CAN?_can_receive?GCANPIF

_can_receive:
                        MOV     A, R7
                        MOV     R3, A
                        MOV     A, R4
                        PUSH    ACC
                        MOV     A, R5
                        PUSH    ACC
                        MOV     R7, #(K_MBX+K_TMO+7)
                        MOV     B, R3
                        MOV     A, R4
                        MOV     R2, A
                        MOV     A, R5
                        MOV     R3, A
                        MOV     R5, B
                        CALL    _os_wait
                        POP     ACC
                        MOV     R5, A
                        POP     ACC
                        MOV     R4, A

                        ; Test ob Timeout
                        CJNE    R7, #TMO_EVENT, CRE_1
                        MOV     R7, #C_TIMEOUT
                        RET

                        ; Testen ob CAN-Task besetzt
CRE_1:                  CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRE_2

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_READ_W_IND_ORDER
                        MOVX    @DPTR, A
                        INC     DPL
                        INC     DPL
                        MOV     A, R4
                        MOVX    @DPTR, A
                        INC     DPL
                        MOV     A, R5
                        MOVX    @DPTR, A

                        MOV     DPH, R4
                        MOV     DPL, R5
                        INC     DPTR      ; Nur Low-Byte nehmen
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM+2
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOV     A, R7
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRE_2:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ B I N D _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Bindet ein bestimmtes (mit CAN_DEF_OBJ) definiertes Objekt an
;*     einen bestimmten Task. Beim Empfang dieses Objekts wird dieser
;*     Task gestartet (er muss mit CAN_WAIT auf dieses Objekt warten).
;*     Diese Funktion implementiert einen besonders schnellen Empfang
;*     eines bestimmten, besonders wichtigen Objektes. Ein Task kann mit
;*     CAN_BIND_OBJ an mehrere Objekte gekoppelt werden (mehrfacher
;*     Aufruf von CAN_BIND_OBJ). Beim Empfang eines dieser Objekte wird
;*     der Task gestartet (wenn er mit CAN_WAIT wartet).
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_BIND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.PARAM[4] := os_running_task_id ();
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_BIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7:   IDENTIFIER  Identifikation des Objekts das fest an
;*                          den aufrufenden Task gebunden werden soll
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde an den Task
;*                          gebunden
;*     C_OBJ_ERROR          Das Objekt mit der angegebenen Identifikation
;*                          ist nicht bekannt oder das Objekt kann nicht
;*                          empfangen werden
;*     C_MEM_FULL           Es wurden bereits acht CAN_BIND_OBJ
;*                          durchgefhrt (mit CAN_UNBIND_OBJ kann wieder
;*                          eine Bindung frei gemacht werden)
;*     C_OBJ_REBIND         Warnung : Das Objekt mit dem angegebenen
;*                          Identifier war bereits an einen Task gebunden.
;*                          Die alte Verbindung wurde gelst und die neue
;*                          aufgebaut.
;*
;*---------------------------------------------------------------------*/


?CAN?_can_bind_obj?GCANAPIF    SEGMENT CODE
                              RSEG    ?CAN?_can_bind_obj?GCANAPIF

_can_bind_obj:
                        MOV     A, R4
                        MOV     R3, A

                        MOV     A, R5
                        MOV     R4, A

                        MOV     A, R6
                        MOV     R5, A

                        MOV     A, R7
                        MOV     R6, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CBO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_BIND_OBJ_ORDER, 4
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM+4
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CBO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ U N B I N D _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Lst eine mit CAN_BIND_OBJ aufgebaute Verbindung zwischen
;*     dem Task und dem Objekt IDENTIFIER. Ab sofort kann dieses
;*     Objekt wieder mit CAN_RECEIVE empfangen werden.
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_UNBIND_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_UNBIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_UNBIND_OBJ?BYTE) :
;*
;*     R6/R7   IDENTIFIER   Identifikation des Objekts
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde vom Task gelst
;*     C_OBJ_ERROR          Das Objekt IDENTIFIER existiert nicht (es
;*                          wurde nicht mit CAN_DEF_OBJ definiert oder
;*                          es wurde nie mit CAN_BIND_OBJ an den Task
;*                          gebunden)
;*
;*---------------------------------------------------------------------*/


?CAN?_can_unbind_obj?GCANAPIF    SEGMENT CODE
                                RSEG    ?CAN?_can_unbind_obj?GCANAPIF

_can_unbind_obj:
                        MOV     A, R4
                        MOV     R3, A

                        MOV     A, R5
                        MOV     R4, A

                        MOV     A, R6
                        MOV     R5, A

                        MOV     A, R7
                        MOV     R6, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CUO_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_UNBIND_OBJ_ORDER, 4

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CUO_1:                  MOV     R7, #C_CAN_FAILURE
                        RET




$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ B I N D _ L A S T _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Bindet 15. (mit CAN_DEF_OBJ) definiertes Objekt an
;*     einen bestimmten Task. Beim Empfang dieses Objekts wird dieser
;*     Task gestartet (er muss mit CAN_WAIT auf dieses Objekt warten).
;*     Diese Funktion implementiert einen besonders schnellen Empfang
;*     eines bestimmten, besonders wichtigen Objektes. Ein Task kann mit
;*     CAN_BIND_OBJ an mehrere Objekte gekoppelt werden (mehrfacher
;*     Aufruf von CAN_BIND_OBJ). Beim Empfang eines dieser Objekte wird
;*     der Task gestartet (wenn er mit CAN_WAIT wartet).
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_BIND_L_ORDER;
;*       C_ORDER_BUF.PARAM[1] := os_running_task_id ();
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_BIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7:   IDENTIFIER        Identifikation des Objekts das fest an
;*                                den aufrufenden Task gebunden werden soll
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde an den Task
;*                          gebunden
;*     C_OBJ_ERROR          Das Objekt mit der angegebenen Identifikation
;*                          ist nicht bekannt oder das Objekt kann nicht
;*                          empfangen werden
;*     C_MEM_FULL           Es wurden bereits acht CAN_BIND_OBJ
;*                          durchgefhrt (mit CAN_UNBIND_OBJ kann wieder
;*                          eine Bindung frei gemacht werden)
;*     C_OBJ_REBIND         Warnung : Das Objekt mit dem angegebenen
;*                          Identifier war bereits an einen Task gebunden.
;*                          Die alte Verbindung wurde gelst und die neue
;*                          aufgebaut.
;*
;*---------------------------------------------------------------------*/


?CAN?can_bind_last_obj?GCANAPIF    SEGMENT CODE
                              RSEG    ?CAN?can_bind_last_obj?GCANAPIF

can_bind_last_obj:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CBO_L_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_BIND_L_OBJ_ORDER, 0

                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM+1
                        MOVX    @DPTR, A

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CBO_L_1:                MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ U N B I N D _ L A S T _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Lst eine mit CAN_BIND_OBJ aufgebaute Verbindung zwischen
;*     dem Task und dem Last Objekt. Ab sofort kann dieses
;*     Objekt wieder mit CAN_RECEIVE empfangen werden.
;*
;* BEGIN
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_UNBIND_L_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_UNBIND_OBJ;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_UNBIND_OBJ?BYTE) :
;*
;*     R6/R7        IDENTIFIER   Identifikation des Objekts
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Objekt IDENTIFIER wurde vom Task gelst
;*     C_OBJ_ERROR          Das Objekt IDENTIFIER existiert nicht (es
;*                          wurde nicht mit CAN_DEF_OBJ definiert oder
;*                          es wurde nie mit CAN_BIND_OBJ an den Task
;*                          gebunden)
;*
;*---------------------------------------------------------------------*/


?CAN?can_unbind_last_obj?GCANAPIF  SEGMENT CODE
                                   RSEG    ?CAN?can_unbind_last_obj?GCANAPIF

can_unbind_last_obj:
                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CUO_L_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_UNBIND_L_OBJ_ORDER, 0

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM+1
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CUO_L_1:                MOV     R7, #C_CAN_FAILURE
                        RET



$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ W A I T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Diese Funktion ist nur im Zusammenhang mit CAN_BIND_OBJ sinnvoll.
;*     Der Task wartet auf den Empfang eines der mit CAN_BIND_OBJ an
;*     diesen Task gebundenen Objekte. Nach dem Empfang wird das
;*     entsprechende Objekt in die durch BUFFER_PTR bezeichnete
;*     Variable kopiert und der Task gestartet.
;*
;* BEGIN
;*    R3 := TIMEOUT;
;*    R4 := HIGH(BUFFER_PTR);
;*    R5 := LOW(BUFFER_PTR);
;*    PUSH R4;
;*    PUSH R5;
;*    PUSH R3;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_ACTIVATE_WRITE_ORDER;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       C_LEAVE_DRIVER;
;*       RETURN;
;*    ELSE
;*       POP R3;
;*       POP R5;
;*       POP R4;
;*       RETURN C_CAN_FAILURE;
;*    END;
;*    POP R3;
;*    RTX_WAIT (K_TMO + K_SIG, R3, 0);
;*    POP R5;
;*    POP R4;
;*    IF RTXRETURN = TMO_EVENT THEN
;*       RETURN C_TIMEOUT;
;*    END;
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_W_TID_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := os_running_task_id;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_WAIT;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_WAIT?BYTE) :
;*
;*     R7      : TIMEOUT           Timeout falls in einer bestimmten Zeit
;*                                 kein Objekt empfangen wurde. Definition
;*                                 analog RTX-51;
;*                                 0        :  Kein Timeout, falls kein
;*                                             Objekt vorhanden ist, luft
;*                                             der Applikations-Task weiter
;*                                             ohne zu warten
;*                                 1..254   :  Anzahl RTX-51 Systemticks
;*                                             die der Applikations-Task
;*                                             auf ein Objekt warten soll
;*                                 255      :  Warten bis ein Objekt
;*                                             empfangen wurde
;*                                             (wait forever)
;*
;*     R4/R5   : HIGH(BUFFER_PTR)  Pointer zu einer Struktur von Typ
;*                                 CAN_MESSAGE_STRUCT im externen RAM.
;*                                 Der CAN-Treiber kopiert das empfangene
;*                                 Objekt in diese Variable.
;*
;*
;*     Returnwert in R7 :
;*
;*        C_OK                 Es wurde ein Objekt empfangen
;*        C_TIMEOUT            Es wurde innerhalb der mit TIMEOUT
;*                             angegebenen Zeit kein Objekt empfangen
;*        C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_wait?GCANPIF       SEGMENT CODE
                             RSEG    ?CAN?_can_wait?GCANPIF

_can_wait:
                        MOV     A, R7
                        MOV     R3, A
                        MOV     A, R4
                        PUSH    ACC
                        MOV     A, R5
                        PUSH    ACC
                        MOV     A, R3
                        PUSH    ACC

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWA_3

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_ACTIVATE_WAIT_ORDER
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     A, R7
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    @DPTR, A
                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        CALL    C_LEAVE_DRIVER
                        JMP     CWA_4

CWA_3:                  POP     ACC
                        POP     ACC
                        POP     ACC
                        MOV     R7, #C_CAN_FAILURE
                        RET

CWA_4:                  MOV     R7, #(K_TMO+K_SIG)
                        POP     ACC
                        MOV     R5, A
                        CALL    _os_wait
                        POP     ACC
                        MOV     R5, A
                        POP     ACC
                        MOV     R4, A

                        ; Test ob Timeout
                        CJNE    R7, #TMO_EVENT, CWA_1
                        MOV     R7, #C_TIMEOUT
                        RET

                        ; Testen ob CAN-Task besetzt
CWA_1:                  CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWA_2

                        ; Befehle an CAN-Task aufsetzen
                        MOV     DPTR, #C_ORDER_BUF_ORDER
                        MOV     A, #CAN_READ_W_TID_ORDER
                        MOVX    @DPTR, A
                        INC     DPTR
                        INC     DPTR
                        MOV     A, R4
                        MOVX    @DPTR, A
                        INC     DPTR
                        MOV     A, R5
                        MOVX    @DPTR, A
                        CALL    os_running_task_id
                        MOV     A, R7
                        MOV     DPTR, #C_ORDER_BUF_ID
                        MOVX    @DPTR, A
                        MOV     DPTR, #C_ORDER_BUF_PARAM+2
                        MOVX    @DPTR, A
                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CWA_2:                  MOV     R7, #C_CAN_FAILURE
                        RET





$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E Q U E S T
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Sendeanforderung (Remote-Frame) fr ein bestimmtes Objekt
;*     aussenden. Der CAN-Treiber sendet ein Remote-Frame und
;*     benachrichtigt die Applikation nach dem Empfang des
;*     entsprechendenden Objekts auf dem blichen Weg (CAN_RECEIVE
;*     oder CAN_WAIT).
;*
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER);
;*    R6 := HIGH(IDENTIFIER);
;*    R7 := LOW(IDENTIFIER);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_REQUEST_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_REQUEST;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_REQUEST?BYTE) :
;*
;*     R6/R7  IDENTIFIER   Identifikation des Kommunikationsobjektes
;*                         entsprechend der CAN-Definition (0 .. 7EFH)
;*
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Das Remote-Frame wird ausgesendet
;*     C_OBJ_ERROR          Das Objekt IDENTIFIER existiert nicht oder
;*                          es kann kein Remote-Frame aussenden
;*     C_BUS_OFF            CAN-Controller ist im Bus-Off Zustand
;*     C_CAN_FAILURE        CAN-Error
;*
;*---------------------------------------------------------------------*/


?CAN?_can_request?GCANAPIF   SEGMENT CODE
                             RSEG    ?CAN?_can_request?GCANAPIF

_can_request:
                        MOV     A, R4
                        MOV     R3, A

                        MOV     A, R5
                        MOV     R4, A

                        MOV     A, R6
                        MOV     R5, A

                        MOV     A, R7
                        MOV     R6, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRQ_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_REQUEST_ORDER, 4

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRQ_1:                  MOV     R7, #C_CAN_FAILURE
                        RET


$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E A D
;*---------------------------------------------------------------------*
;*  Funktion:
;*     Mit dieser Funktion kann jederzeit die gerade aktuelle Version
;*     jedes Objekts gelesen werden (unabhngig davon, ob die Objekte
;*     mit CAN_DEF_OBJ als Empfangs- oder Sende-Objekte konfiguriert
;*     wurden). Diese Funktion ist kein Ersatz fr CAN_RECEIVE, sondern
;*     ist vor allem whrend der Testphase des Applikationstask ntzlich.
;*
;* VAR
;*    IND : BYTE;
;* BEGIN
;*    R4 := HIGH(IDENTIFIER);
;*    R5 := LOW(IDENTIFIER)
;*    R6 := HIGH(BUFFER_PTR);
;*    R7 := LOW(BUFFER_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R4;
;*       C_ORDER_BUF.PARAM[1] := R5;
;*       C_ORDER_BUF.PARAM[2] := R6;
;*       C_ORDER_BUF.PARAM[3] := R7;
;*       C_ORDER_BUF.PARAM[4] := b_ptr_h;
;*       C_ORDER_BUF.PARAM[5] := b_ptr_l ;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END;
;* END CAN_READ;
;*
;*---------------------------------------------------------------------*
;*  Parameter (abgespeichert ab ?CAN_READ?BYTE) :
;*
;*    R4/R7   : IDENTIFIER      Identifikation des Kommunikationsobjektes
;*                              entsprechend der CAN-Definition (0 .. 7EFH)
;*    b_ptr_h HIGH(BUFFER_PTR)  Pointer zu einer Struktur von Typ
;*    b_ptr_l LOW(BUFFER_PTR)   CAN_MESSAGE_STRUCT im externen RAM.
;*                              Der CAN-Treiber kopiert das Objekt in
;*                              diese Variable.
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Objekt IDENTIFIER gelesen
;*     C_OBJ_ERROR          Objekt IDENTIFIER existiert nicht
;*
;*---------------------------------------------------------------------*/


?XD?_can_read?GCANAPIF        SEGMENT XDATA
                                RSEG ?XD?_can_read?GCANAPIF
?_can_read?BYTE:
ident_r:    DS 4
b_ptr_h:    DS 1
b_ptr_l:    DS 1


?CAN?_can_read?GCANAPIF     SEGMENT CODE
                            RSEG    ?CAN?_can_read?GCANAPIF

_can_read:

                        MOV     A,R4
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    @DPTR, A

                        MOV     A,R5
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 1
                        MOVX    @DPTR, A

                        MOV     A,R6
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 2
                        MOVX    @DPTR, A

                        MOV     A,R7
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 3
                        MOVX    @DPTR, A

                        MOV     DPTR, #b_ptr_h
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 4
                        MOVX    @DPTR, A

                        MOV     DPTR, #b_ptr_l
                        MOVX    A, @DPTR
                        MOV     DPTR, #C_ORDER_BUF_PARAM + 5
                        MOVX    @DPTR, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CRD_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_READ_ORDER, 0

                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CRD_1:                  MOV     R7, #C_CAN_FAILURE
                        RET


$EJECT
;*---------------------------------------------------------------------*
;*     C A N _ R E A D _ L A S T _ O B J
;*---------------------------------------------------------------------*
;*  Funktion:
;*
;* BEGIN
;*    R3 := HIGH(MSG_PTR);
;*    R4 := LOW(MSG_PTR);
;*    IF C_ENTER_DRIVER THEN
;*       C_ORDER_BUF.ORDER := CAN_READ_L_OBJ_ORDER;
;*       C_ORDER_BUF.PARAM[0] := R3;
;*       C_ORDER_BUF.PARAM[1] := R4;
;*       C_ORDER_BUF.TASK_ID := os_running_task_id ();
;*       os_send_signal an CAN-Task;
;*       os_wait (K_SIG,0FFH,0);
;*       PUSH(C_ORDER_BUF.PARAM[0]);  (* Returnwert auf Stack pushen *)
;*       C_LEAVE_DRIVER;
;*       POP(ACC);                    (* Returnwert in Akku *)
;*       RETURN;
;*    ELSE
;*       RETURN C_CAN_FAILURE;
;*    END IF;
;* END CAN_WRITE;
;*
;*---------------------------------------------------------------------*
;*  Parameter :
;*
;*     R6/R7   : MSG_PTR         Pointer zu einer Struktur vom Typ
;*
;*
;*     Returnwert in R7 :
;*
;*  Returnwert in R7 :
;*
;*     C_OK                 Objekt IDENTIFIER gelesen
;*     C_OBJ_ERROR          Objekt IDENTIFIER existiert nicht
;*
;*---------------------------------------------------------------------*/


?CAN?_can_read_last_obj?GCANPIF  SEGMENT CODE
                                 RSEG    ?CAN?_can_read_last_obj?GCANPIF

_can_read_last_obj:
                        MOV     A, R6
                        MOV     R3, A
                        MOV     A, R7
                        MOV     R4, A

                        ; Testen ob CAN-Task besetzt
                        CALL    C_ENTER_DRIVER
                        CJNE    A, #TRUE, CWR_L_1

                        ; Befehle an CAN-Task aufsetzen
                        SETUP_ORDER CAN_READ_L_OBJ_ORDER, 2
                        ; CAN-Task starten
                        MOV     R7, #C_DRIVER_ID
                        CALL    _os_send_signal
                        MOV     R7, #K_SIG
                        CALL    _os_wait
                        ;Returnwert retten
                        MOV     DPTR, #C_ORDER_BUF_PARAM
                        MOVX    A, @DPTR
                        PUSH    ACC
                        CALL    C_LEAVE_DRIVER
                        POP     ACC
                        MOV     R7, A
                        RET

CWR_L_1:                MOV     R7, #C_CAN_FAILURE
                        RET



;=======================================================================
;
;     ENDE DES INCLUDE FILE GCANAP_2.INC
;
;=======================================================================


