$TITLE ('RTX-51/FCAN HW-DEFINITIONS')
$NOXREF
$NOSYMBOLS
$NORB
$DEBUG
$PAGELENGTH(80) PAGEWIDTH(110)
;************************************************************************
;************************************************************************
;*                                                                      *
;*  HW-DEFINITIONS FOR RTX-51 / FULL-CAN DRIVER                         *
;*                                                                      *
;************************************************************************
;************************************************************************
;*                                                                      *
;*  PURPOSE:        User confuguration of HW-Adresses, Buffer           *
;*                  allocation and interrupts for the                   *
;*                  RTX-51/FCAN-Driver                                  *
;*                  This source file is part of the RTX-51/CAN          *
;*                  object code disk.                                   *
;*                                                                      *
;*  FILENAME:       GCANCONF.A51                                        *
;*                                                                      *
;*  MODULENAME:     --                                                  *
;*                                                                      *
;*  TARGETSYSTEM:   Any system based upon 8051 up with Intel 82527      *
;*                  CAN-Controller.                                     *
;*                                                                      *
;*  LANGUAGE:       Keil ASM-51                                         *
;*                                                                      *
;************************************************************************
;*  REVISION HISTORY :                                                  *
;*                                                                      *
;*  - 28. JAN 1991; Th. Fischler; Rev 0.1 :                             *
;*       First Version                                                  *
;*  - 27. MAY 1991; Th. Fischler; Rev 0.2 :                             *
;*       MAX_NBR_OF_SEND_TRIALS added                                   *
;*  - 11. OCT 1991; Th. Fischler; Rev 1.0                               *
;*       Adapted for RTX-51 V4.0                                        *
;*  - 25. Feb. 1994: Gl -> CAN_INT_NBR ok now for values <> 0           *
;*                                                                      *
;*  - 04. JAN 1996; K. Birsen;                                          *
;*       Adapted (CONTROLLER_BASE) for 82527                            *
;************************************************************************
;*    Copyright 1991 .. 2001 METTLER  &  FUCHS  AG,  CH-8953 Dietikon   *
;************************************************************************


PUBLIC  FCAN_REG
PUBLIC  CAN_INT_NBR
PUBLIC  NBR_OF_SEND_TRIALS


;************************************************************************
;*                                                                      *
;*   THE FOLLOWING VALUES CAN BE ALTERED BY THE USER                    *
;*                                                                      *
;************************************************************************


CONTROLLER_BASE         EQU 0EC00H      ; XDATA start-address of the
                                        ; CAN-Controller


; The following constant defines the interrupt-number (as defined by
; RTX-51 V4.0) for the CAN-Controller

USED_CAN_INT_NBR        EQU     0


; The next constant defines the number of send-trials for the first
; communication object after startup.
; (0 to 60000 / Default 20000)

MAX_NBR_OF_SEND_TRIALS  EQU 20000

;************************************************************************
;*                                                                      *
;*   DO NOT ALTER THE FOLLOWING DECLARATIONS !!!                        *
;*                                                                      *
;************************************************************************

; CAN-Controller declarations

                        XSEG AT CONTROLLER_BASE
FCAN_REG:               DS 256                    ; Number of bytes for the
                                                  ; Intel 82527 Controller

; Constant declaration
?CO?CAN_CONST_SEG          SEGMENT         CODE
                           RSEG            ?CO?CAN_CONST_SEG
NBR_OF_SEND_TRIALS:        DW MAX_NBR_OF_SEND_TRIALS
CAN_INT_NBR:               DB USED_CAN_INT_NBR

;
;   END OF MODULE
    END
